#!/usr/bin/env php
<?php
$script_file = __FILE__;

# Fix all timezones record without olson_name

$original_dir = getcwd();
chdir(str_replace('/scripts/syno-tz-check.php','/htdocs', $script_file));

require_once("./always.php");

chdir($original_dir);

  $sql  = "SELECT tzid FROM timezones WHERE olson_name is null or olson_name=''";
  $sql2 = 'UPDATE timezones set olson_name=:olson_name WHERE tzid=:tzid';
  $qry = new AwlQuery($sql);
  if ( !$qry->Exec('tz/update',__LINE__,__FILE__)) {
	printf("select timezone failed, sql=$sql\n");
	exit(1);
  }

  if( $qry->rows() < 1 ) {
	/* no timezone need to update */
	printf("nothing should fix\n");
	exit(0);
  }

  while( $row = $qry->Fetch() ) {
	  unset($olson_name);
      $update_param = array();
	  $olson_name = olson_from_tzstring($row->tzid);

	  if(!isset($olson_name) || $olson_name == '') {
		  printf("get olson_name failed, tzid=$row->tzid\n");
		  continue;
	  }

	  $update_param[':olson_name'] = $olson_name;
	  $update_param[':tzid'] = $row->tzid;
	  $qry2 = new AwlQuery($sql2, $update_param);
	  if ( !$qry2->Exec('PUT',__LINE__,__FILE__) ) {
		  printf("update timezone failed, sql=$sql2\n");
		  continue;
	  }
	  printf("update timezone ok, tzid=$row->tzid, olson_name=$olson_name\n");
  }


exit(0);
