'use strict';
var google = require('googleapis');
var logger = require('../../jslib/logger/command.js');
var utils = require('../../jslib/common/index.js');
function listCalendars(oauth2Client) {
	var calendar = google.calendar('v3');
	calendar.calendarList.list({
		minAccessRole: 'owner',
		auth: oauth2Client
	}, function(err, response) {
		if (err) {
			logger.debug(err);
			logger.debug(response);
			utils.onDestroy();
		}
		var calendars = response.items;
		if (calendars.length === 0) {
			logger.debug('No calendars found.');
		} else {
			var ret = [];
			calendars.forEach(function(calendar) {
				var cal = {
					remote_cal_id: calendar.id,
					remote_cal_displayname: calendar.summary
				};
				ret.push(cal);
			});
			console.log(JSON.stringify(ret));
		}
	});
}

module.exports = listCalendars;
