'use strict';
var google = require('googleapis');
var gUtils = require('./utils.js');
var logger =  require('../../jslib/logger/command.js');
var utils =  require('../../jslib/common/index.js');

function listRepeatEvent(oauth2Client, iCalUID, calendarId, done, appendVEvents, tzidList) {
	var calendar = google.calendar('v3'),
		events = '',
		params = {
			auth: oauth2Client,
			calendarId: calendarId,
			iCalUID: iCalUID
		};
	calendar.events.list(params, function(err, response) {
		if (err) {
			logger.debug('The API returned an error: ' + err, response);
			utils.onDestroy();
		}
		events = gUtils.handleRepeatEventResponse(response, tzidList);
		appendVEvents(events);
		done();
	});
}

module.exports = listRepeatEvent;
