'use strict';
var logger =  require('../jslib/logger/command.js');
var utils = require('../jslib/common/index.js');
var serviceProviderFactory = require('./factory.js');
var filePath = process.argv[2];

if (!filePath) {
	utils.onDestroy();
}

var options = utils.readFile(filePath);
var serviceProvider = serviceProviderFactory.create(options);

var onDestroy = function () {
	serviceProvider.destroy();
	utils.onDestroy();
}

process.on('SIGUSR2', onDestroy);
process.on('SIGINT', onDestroy);

if ('cal_list' === options.method) {
	logger.debug('Start listing calendar');
	serviceProvider.listCalendars();
} else if ('cal_import' === options.method) {
	logger.debug('Start importing calendar ' + options.cal_displayname);
	serviceProvider.listEvents();
}

