var fs = require('fs');
var logger = require('../logger/command.js');

function onDestroy() {
	process.exit(-1);
}

function readFile(filePath) {
	try {
		var content = fs.readFileSync(filePath);
		return JSON.parse(content);
	} catch (e) {
		logger.debug(e);
		onDestroy();
	}
}

module.exports = {
	onDestroy: onDestroy,
	readFile: readFile
}
