var http = require('http').createServer();
var io = require('socket.io')(http);
var relay_send_sock = process.env.npm_package_config_relay_send_domain_socket_path;

io.on('connection', function(socket){
	socket.on('register', function(data){
		socket.join(decodeURIComponent(data.username));
		console.log("## User: " + data.username + " is connected. Total: " + Object.keys(io.sockets.sockets).length);
	});
	socket.on('disconnect', function() {
		console.log("disconnected");
	});
});
var relay_server_send_connect = function() {
	http.listen(relay_send_sock, function(){
		child_process.execFile('chown', ['http:http', relay_send_sock], function(err, stdout, stderr) {
			logger.debug('listening on ' + relay_send_sock);
		});
		child_process.execFile('chmod', ['777', relay_send_sock], function(err, stdout, stderr) {
			logger.debug('listening on ' + relay_send_sock);
		});
	});
};
http.on("error", function(e) {
	if ('EADDRINUSE' == e.code) {
		fs.unlinkSync(relay_send_sock);
		relay_server_send_connect();
	}
});
relay_server_send_connect();

var fs = require('fs');
var relay_receive_sock = process.env.npm_package_config_relay_receive_domain_socket_path;
var logger = require('../jslib/logger');
var child_process = require('child_process');
var relay_server_receive = require('./relay_receive')(io);

var onDestroy = function() {
	console.log("on Destroy");
	relay_server_receive.close(function() {
		process.exit();
	});
	io.close();
}

var relay_server_receive_connect = function () {
	relay_server_receive.listen(relay_receive_sock, function() {
		child_process.execFile('chown', ['synocalendar:synocalendar', relay_receive_sock], function(err, stdout, stderr) {
			logger.debug('listening on ' + relay_receive_sock);
		});
		child_process.execFile('chmod', ['777', relay_receive_sock], function(err, stdout, stderr) {
			logger.debug('listening on ' + relay_receive_sock);
		});
	});
};
relay_server_receive_connect();
relay_server_receive.on('error', function(e) {
	if ('EADDRINUSE' == e.code) {
		fs.unlinkSync(relay_receive_sock);
		relay_server_receive_connect();
	}
});

process.on('SIGINT', onDestroy);
