var assert = require('assert');
var ICSGenerator = require('../jslib/evt_adapter/index.js');

describe('ICSGenerator', function() {
	describe('#convertToHourDay()', function() {
		it('0 >= min return "" ', function() {
			assert.equal("", ICSGenerator.convertToHourDay(-2));
		});
		it('10 min return -PT10M', function() {
			assert.equal("-PT10M", ICSGenerator.convertToHourDay(10));
		});
		it('60 min return -PT1H ', function() {
			assert.equal("-PT1H", ICSGenerator.convertToHourDay(60));
		});
		it('1440 min return -P1D ', function() {
			assert.equal("-P1D", ICSGenerator.convertToHourDay(1440));
		});
		it('1501 min return -P1DT1H1M ', function() {
			assert.equal("-P1DT1H1M", ICSGenerator.convertToHourDay(1501));
		});
		it('1441 min return -P1DT1M ', function() {
			assert.equal("-P1DT1M", ICSGenerator.convertToHourDay(1441));
		});
	});
	describe('#formVTodo', function() {
		it('create vtodo', function() {
			var vtodo = ICSGenerator.formIcal({
				summary: 'Calendar Scrum',
				dtstart: 'TZID=Asia/Taipei:20170117T100000',
				due: 'TZID=Asia/Taipei:20170117T110000',
				description: 'Never delay',
				location: '5A',
				uid: 'a8tli2mqojth0jqthtmm6tpio0',
				is_all_day: false
			});
			assert.equal(`
BEGIN:VCALENDAR
PRODID:-//Synology//EN\n
VERSION:2.0
BEGIN:VTODO
CREATED:20170309T141720
LAST-MOD:20170309T141720
UID:a8tli2mqojth0jqthtmm6tpio0
DTSTAMP:20170309T141720
SUMMARY:Calendar Scrum
DTSTART;TZID=Asia/Taipei:20170117T100000
DUE;TZID=Asia/Taipei:20170117T100000
PRIORITY:0
PERCENT:0
DESCRIPTION:Never delay
LOCATION:5A
END:VTODO
END:VCALENDAR
			`.trim(), vtodo);
			console.log(vtodo);
		});
	});
});
