#!/bin/sh
# Copyright (c) 2000-2017 Synology Inc. All rights reserved.

synocalendar="/var/packages/Calendar/target/tool/synocalendar"

case "$1" in
	--sdk-mod-ver)
		echo "1.0";
		;;
	--name|--pkg-ver|--vendor)
		${synocalendar} $1
		;;
	--pre)
		 ;;
	--post)
		#check app is stopped
		if [ -f "/var/packages/Calendar/enabled" ]; then
			/bin/echo "[ERROR] Calendar is running" >> /var/log/synocal.log
			exit 0
		fi
		#check config
		if [ ! -f "/usr/syno/etc/packages/Calendar/share_link.json" ]; then
			exit 0
		fi

		#cp attachments
		oldAttachBasePath=`${synocalendar} --attach-base-path-get`
		if [ ! -d ${oldAttachBasePath} ]; then
			/bin/echo "Attach base path is empty" >> /var/log/synocal.log
			exit 0
		fi
		newVolume=`echo ${NEW_PATH} | sed -e 's/\(.*\)@appstore\/.*/\1/g'`
		newAttachBasePath="${newVolume}@calendar/attach"

		if [ ! -d "${newAttachBasePath}" ]; then
			/bin/mkdir -p ${newAttachBasePath}
			/bin/chmod 700 ${newAttachBasePath}
			/bin/chown root ${newAttachBasePath}
		fi

		#oldSize=`du -s $oldAttachBasePath | cut -d$'\t' -f1`
		/bin/cp -rpf ${oldAttachBasePath}/* ${newAttachBasePath}

		if [ $? -eq 1 ]; then
			exit 0;
		fi

		#newSize=`du -s $newAttachBasePath | cut -d$'\t' -f1`
		#if [ $oldSize != $newSize ]; then
		#	exit 0;
		#fi

		#update config file
		${synocalendar} --attach-base-path-set path=${newAttachBasePath}

		#remove old attachments

		if [ ! -z $oldAttachBasePath ]; then
			if [[ $oldAttachBasePath =~ "/volume".*"/@calendar/attach" ]] && [[ ! $oldAttachBasePath =~ "/../" ]];then
				/bin/echo "Change volume from ${oldAttachBasePath} to ${newAttachBasePath}. Remove old one." >> /var/log/synocal.log
				/bin/rm -rf ${oldAttachBasePath} >> /var/log/synocal.log 2>&1
			fi
		fi
		;;
	*)
		echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre|--post"
		;;
esac
exit 0
