#!/bin/bash
# Usage
# ./bind.sh https://SERVERBASE USERNAME SHARED_RESOURCE SEGMENT_NAME
# example
#  share b/home calendar to user a
# ./bind.sh http://127.0.0.1:38008 a /caldav.php/b/home b_home

CAT=/bin/cat
ECHO=/bin/echo

BASE="$1"
USER="$2"
RESOURCE="$3"
NAME="${4:-${3##*/}}"

URL="$BASE/caldav.php/$USER/"


REQUEST=`$CAT <<EOF
<?xml version="1.0" encoding="utf-8"?>
<bind xmlns="DAV:">
    <segment>$NAME</segment>
	<href>$RESOURCE</href>
</bind>
EOF`

$ECHO $REQUEST | curl -k -d @- -X BIND -u $USER -H "content-type: text/xml charset=\"UTF-8\"" -H "user-agent: bind-script" $URL
