. /var/packages/Calendar/target/tool/common

$PSQL ${DBA} -c "CREATE DATABASE calendar;" >/dev/null 2>&1

# creae user, skip system create

# create db, by worker, skip
#createdb -U postgres --encoding SQL_ASCII --template template0 --owner "postgres" "calendar"
#if ! createdb --encoding UTF8 --template template0 --owner "${AWL_DBAUSER}" ${PSQLOPTS} "${DBNAME}" ; then
#	echo "Unable to create database"
#	exit 1
#fi

# create_plpgsql_language skip


#
# Load the AWL base tables and schema management tables
#$PSQL -qXAt ${PSQLOPTS} ${DBA} -f "${AWLDIR}/dba/awl-tables.sql" "${DBNAME}" 2>&1
#$PSQL -qXAt ${PSQLOPTS} ${DBA} -f "${AWLDIR}/dba/schema-management.sql" "${DBNAME}" 2>&1

#
# Load the DAViCal tables
#$PSQL -qXAt ${PSQLOPTS} ${DBA} -f "${DBADIR}/davical.sql" "${DBNAME}" 2>&1

# Set permissions for the application DB user on the database
#if ! ${DBADIR}/update-davical-database ${DBAOPTS} --dbname "${DBNAME}" --appuser "${AWL_APPUSER}" --nopatch --owner "${AWL_DBAUSER}" ; then

$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/davical.schema"

# Load DB table
$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/awl_db_revision.table"

# Create new table
$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/syno_user_setting.table"
$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/syno_cal_obj.table"
$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/syno_cal_sharing.table"
$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/syno_user_info.table"
$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/syno_cal_config.table"
$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/syno_invite_mail_user.table"
$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/syno_auth_foreign.table"
$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/syno_cal_map.table"
# 1.3
$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/syno_evt_attach_check.table"

# Alter table
# 1.0
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE calendar_alarm ADD COLUMN RECURRENCE_ID text;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE calendar_attendee ADD COLUMN RECURRENCE_ID text;"
# 1.2 (201705)
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE calendar_item ADD COLUMN gps text;"
#$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE collection ADD COLUMN is_evt bool;"
#$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE collection ADD COLUMN is_todo bool;"
$PSQL ${DBA} -d ${DBNAME} -c "CREATE SEQUENCE calendar_item_priority_order_seq START 1;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER SEQUENCE calendar_item_priority_order_seq OWNED BY calendar_item.priority_order;"
$PSQL ${DBA} -d ${DBNAME} -c "GRANT ALL ON SEQUENCE calendar_item_priority_order_seq TO synocalendar;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE calendar_item ADD COLUMN priority_order bigint DEFAULT nextval('calendar_item_priority_order_seq'::regclass);"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE calendar_item ADD COLUMN from_syno_app_url text;"
#$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_user_setting ADD COLUMN todo_clean_complete_expire_min integer;"
#$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_user_setting ALTER COLUMN todo_clean_complete_expire_min SET DEFAULT 129600;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_user_setting ADD COLUMN default_plugin_mode TEXT;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_user_setting ADD COLUMN default_todo_view TEXT;"
# 1.3 (201709)
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_user_setting ADD COLUMN show_week_numbers BOOL;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_user_setting ADD COLUMN enable_keyboard_shortcut BOOL;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_user_setting ADD COLUMN last_used_map_type TEXT;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE sync_changes ADD COLUMN logged_user integer;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_cal_obj ADD COLUMN notify_evt_by_mail           BOOL DEFAULT FALSE;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_cal_obj ADD COLUMN notify_evt_by_browser        BOOL DEFAULT TRUE;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_cal_obj ADD COLUMN notify_import_cal_by_mail    BOOL DEFAULT TRUE;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_cal_obj ADD COLUMN notify_import_cal_by_browser BOOL DEFAULT TRUE;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_cal_obj ADD COLUMN notify_alarm_by_mail         BOOL DEFAULT TRUE;"
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE syno_cal_obj ADD COLUMN notify_alarm_by_browser      BOOL DEFAULT TRUE;"
# 1.4 (201711)
$PSQL ${DBA} -d ${DBNAME} -c "ALTER TABLE calendar_item ADD COLUMN evt_color text;"

# Alter Function
$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/syno_sql_funciton.sql"

$PSQL ${DBA} -d ${DBNAME} < "$PKG_DIR_TOOL/syno_add_index.sql"
#if 0
#remove reindex when upgrade pkg
#endf if
$PSQL ${DBA} -d ${DBNAME} -c "reindex database calendar;"

# Add function and create trigger
$PSQL -U postgres -d calendar -a -f "$PKG_DIR_TOOL/trigger.sql"


