#!/bin/bash

PKG_DIR=/var/packages/Calendar
PKG_DIR_TARGET=$PKG_DIR/target
PKG_DIR_TOOL=$PKG_DIR_TARGET/tool

AWL_DBAUSER=postgres
PSQL=/bin/psql
DBA="-U ${AWL_DBAUSER}"
DBNAME=calendar

Control()
{
       if [ -f "/usr/syno/bin/synosystemctl" ]; then
               synosystemctl $*
       else
               initctl $*
       fi
}

create_tmp_dir()
{
	[ -d "/tmp/synocalendar" ] || /bin/mkdir -p /tmp/synocalendar
	/bin/chmod 777 /tmp/synocalendar
	/bin/chown postgres /tmp/synocalendar
}

create_tablespace()
{
	create_tmp_dir
	Control start pgsql
	Control start pgsql-adapter
	/bin/sleep 2

	psql -U postgres calendar -qt -c "SELECT * FROM syno_cal_notify;"
	ret=$?
	if [ "$ret" -ne "0" ] ; then
		drop_tablespace
	fi
	ret=`psql -U postgres calendar -qt -c "SELECT count(*) FROM pg_tablespace where spcname='synocalendar_tmp';"`
	if [ "$ret" -ne "1" ] ; then
		$PSQL -U postgres -d calendar -c "CREATE TABLESPACE synocalendar_tmp LOCATION '/tmp/synocalendar';"
		$PSQL ${DBA} --set ON_ERROR_STOP=on ${DBNAME} < "$PKG_DIR_TOOL/syno_cal_notify.table"
	fi
	return 0
}
drop_tablespace()
{
	echo "== check syno_cal_notify ==" >> /var/log/synocal.log 2>&1
	psql -U postgres calendar -c '\d syno_cal_notify;'
	ret=$?
	if [ "$ret" -eq "0" ] ; then
		echo "== drop syno_cal_notify ==" >> /var/log/synocal.log 2>&1
		$PSQL -U postgres -d calendar -c "DROP TABLE syno_cal_notify";
	fi
	ret=$?
	if [ "$ret" -eq "1" ] ; then
		return 1
	fi

	echo "== check tablespace synocalendar_tmp ==" >> /var/log/synocal.log 2>&1
	ret=`psql -U postgres calendar -qt -c "SELECT count(*) FROM pg_tablespace where spcname='synocalendar_tmp';"`
	if [ "$ret" -eq "1" ] ; then
		echo "== drop tablespace synocalendar_tmp ==" >> /var/log/synocal.log 2>&1
		$PSQL -U postgres -d calendar -c "DROP TABLESPACE synocalendar_tmp";
	fi
	ret=$?
	if [ "$ret" -eq "1" ] ; then
		return 1
	fi
	rm -rf /tmp/synocalendar/*
	return 0
}
case $1 in
	create)
		create_tablespace
		ret=$?
		if [ "$ret" -eq "1" ] ; then
			exit 1
		fi
		exit 0
		;;
	drop)
		drop_tablespace
		ret=$?
		if [ "$ret" -eq "1" ] ; then
			exit 1
		fi
		exit 0
		;;
	create_tmp_dir)
		create_tmp_dir
		ret=$?
		if [ "$ret" -eq "1" ] ; then
			exit 1
		fi
		exit 0
		;;
esac
