# download timezone ics file
 wget -r http://tzurl.org/zoneinfo/ -A ics -I zoneinfo

# only keep the VTIMEZONE part

file_list=`find "tzurl.org/zoneinfo/" -iname "*.ics"`
for file in $file_list; do
	echo $file;
	from=`grep -n "BEGIN:VTIMEZONE" $file | cut -d':' -f1`
	to=`grep -n "END:VTIMEZONE" $file | cut -d':' -f1`
	mkdir -p "zone_final/${file}"
	awk "NR >= ${from} && NR <= ${to}" < $file > tmp
	cat tmp > $file
done
rm tmp

# run tz-update.php to import vtimezone.ics
# 1. run by php56
# 2. change /synocalendar/conf/davical_config.php user to postgres
/usr/local/bin/php56 -d open_basedir="/" /var/packages/Calendar/target/davical/scripts/tz-update.php localhost "/var/packages/Calendar/target/tool/tzurl.org/zoneinfo/"

# export timezones table
pg_dump -U postgres -d calendar --data-only -t timezones > timezone.sql
